
package org.omegahat.DataStructures.Data;

public class BasicFactorLevelSet 
             extends org.omegahat.Environment.Utils.OrderedTable 
             implements FactorLevelSetInt
{

 /**
    Initializing constructor that pre-allocates a specifiable space
    for elements to be added in the future.
  */
public BasicFactorLevelSet(int size)
{
 super(size);
}

public BasicFactorLevelSet(Object []str) 
{
  addElements(str, true);
}

public BasicFactorLevelSet(Object value) 
{
  add(value);
}

public BasicFactorLevelSet(java.util.Vector v)
{
  this(v,true);  
}

public BasicFactorLevelSet(java.util.Vector v, boolean copy) 
{

 this(v.size());
 addElements(v);
}

  /**
     Default Constructor for use by derived classes
     and for empty initialization.
   */
public BasicFactorLevelSet() {
}


public int addElements(java.util.Vector v, boolean append) 
{
 if(append == false)
    clear();

  for(java.util.Enumeration e = v.elements() ; e.hasMoreElements() ;) {
    add(e.nextElement());
  }

 return(size());
}


public int addElements(java.util.Vector v) {
  return(addElements(v, true));
}

public int addElements(Object [] str, boolean append) {
   if(append == false)
    clear();

   for(int i=0; i < str.length; i++) {
      if(!containsKey(str[i])) {
        put(str[i], new Integer(i));
      } else
        throw new RuntimeException("Duplicate levels");
    }
 return(size());
}

/**
 Return the values of the level set as an array
*/
public Object[] levels() {
 return( orderedKeys().toArray() );
}

 /**
   Get the level element corresponding to the specified code.
   @see #indexOf(java.lang.Object)
  */
public Object level(int which) {
 which = ordered().indexOf(new Integer(which));
 return(orderedKeys().elementAt(which));
}

/**
  Lookup the index or code for the specified element of the level set.
*/
public int indexOf(Object level) {
  return(ordered().indexOf(level));
}

}

/*
Copyright (c) 1998, 1999 The Omega Project for Statistical Computing.
     All rights reserved.

     Redistribution and use in source and binary forms, with or without
     modification, are permitted provided that the following conditions are
     met:

       Redistributions of source code must retain the above copyright notice,
       this list of conditions and the following disclaimer.

       Redistributions in binary form must reproduce the above copyright
       notice, this list of conditions and the following disclaimer in the
       documentation and/or other materials provided with the distribution.

       Neither name of the Omega Project for Statistical Computing nor the 
       names of its contributors may be used to endorse or promote products 
       derived from this software without specific prior written permission.

     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS'' AND ANY
     EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
     SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
     SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
     PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
     INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
     STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
     THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
*/

